• 0 Posts
  • 3 Comments
Joined 1 year ago
cake
Cake day: June 25th, 2023

help-circle
  • I’ve only ever seen two parts of git that could arguably be called unintuitive, and they both got fixes:

    • git reset seems to do 2 unrelated things for some people. Nowadays git restore exists.
    • the inconsistent difference between a..b and a...b commit ranges in various commands. This is admittedly obscure enough that I would have to look up the manual half the time anyway.
    • I suppose we could call the fact that man git foo didn’t used to work unintuitive I guess.

    The tooling to integrate git submodule into normal tree operations could be improved though. But nowadays there’s git subtree for all the people who want to do it wrong but easily.


    The only reason people complain so much about git is that it’s the only VCS that’s actually widely used anymore. All the others have worse problems, but there’s nobody left to complain about them.


  • Two of the most expensive things a shell does are call fork and call execve for an external program. pwd is a builtin (at least for bash) but the former still applies. $PWD exists even if you don’t want that shortening; just like your backticks be sure to quote it once so it doesn’t get expanded when assigning to PS1.

    In general, for most things you might want to do, you can arrange for variables to be set ahead of time and simply expanded at use time, rather than recalculating them every time. For example, you can hook cd/pushd/popd to get an actually-fast git prompt. Rather than var=$(some_function) you should have some_function output directly to a variable (possibly hard-coded - REPLY is semi-common; you can move the value later); printf -v is often useful. Indirection should almost always be avoided (unless you do the indirect-unset bash-specific hack or don’t have any locals) due to shadowing problems (you have to hard-code variable name assumptions anyway so you might as well be explicit).


  • That doesn’t seem sensible. Moving the cursor will confuse bash and you can get the same effect by just omitting the last \n.

    Note that bash 5.0, but not earlier or later versions, is buggy with multiline prompts even if they’re correct.

    Your colors should use 39 (or 49) for reset.

    Avoid doing external commands in subshells when there’s a perfectly good prompt-expansion string that works.

    You seem to be generating several unnecessary blank lines, though I haven’t analyzed them in depth; remember that doing them conditionally is an option, like I do:

    #PS1 built up incrementally before this, including things like setting TTY title for appropriate terminals
    PS0='vvv \D{%F %T%z}\n'
    PS1='^^^ \D{%F %T%z}\n'"$PS1"
    prompt-command-exit-nonzero()
    {
        # TODO map signal names and <sysexits.h> and 126/127 errors?
        # (128 also appears in some weird job-control cases; there are also
        # numerous cases where $? is not in $PIPESTATUS)
        # This has to come first since $? will be invalidated.
        # It's also one of the few cases where `*` is non-buggy for an array.
        local e=$? pipestatus="${PIPESTATUS[*]}"
        # Fixup newline. Note that interactive shells specifically use stderr
        # for the prompt, not stdin, stdout, or /dev/tty
        printf '\e[93;41m%%\e[39;49m%'"$((COLUMNS-1))"'s\r' >&2
        # if e or any pipestatus is nonzero
        if [[ -n "${e/0}${pipestatus//[ 0]}" ]]
        then
            if [[ "$pipestatus" != "$e" ]]
            then
                local pipestatus_no_SIGPIPE="${pipestatus//141 /}"
                local color=41
                if [[ -z "${pipestatus_no_SIGPIPE//[ 0]}" ]]
                then
                    color=43
                fi
                printf '\e[%smexit_status: %s (%s)\e[49m\n' "$color" "$e" "${pipestatus// / | }" >&2
            else
                printf '\e[41mexit_status: %s\e[49m\n' "$e" >&2
            fi
        fi
    }
    PROMPT_COMMAND='prompt-command-exit-nonzero'